
// No3Dlg.cpp : t@C
//

#include "stdafx.h"
#include "No3.h"
#include "No3Dlg.h"
#include "afxdialogex.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

#include <complex>
using namespace std;


#define MAXDANSUU 1000
#define MAXHAKEI 100000
#define PAI 3.141592653589
#define abs1(x) ((x)<0 ? -(x) : (x))

char symbuf[1024];
double f_max, f_min, Y_max, Y_memori;
double gain_hosei;
double sampling_period;			/* s		*/
int output_node;
int n_element, max_node;
int n_hakei;
int type[MAXDANSUU], node[2][MAXDANSUU];
double LCR_value[MAXDANSUU];
double hakei_data[MAXHAKEI];
complex<double> DFT[MAXHAKEI], IDFT[MAXHAKEI];
complex<double> Y[MAXDANSUU][MAXDANSUU];

// AvP[Ṽo[WɎg CAboutDlg _CAO

class CAboutDlg : public CDialogEx
{
public:
	CAboutDlg();

// _CAO f[^
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV T|[g

// 
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialogEx(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialogEx)
END_MESSAGE_MAP()


// CNo3Dlg _CAO



CNo3Dlg::CNo3Dlg(CWnd* pParent /*=NULL*/)
	: CDialogEx(CNo3Dlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CNo3Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CNo3Dlg, CDialogEx)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDOK, &CNo3Dlg::OnBnClickedOk)
	ON_BN_CLICKED(IDC_BUTTON1, &CNo3Dlg::OnBnClickedButton1)
END_MESSAGE_MAP()


// CNo3Dlg bZ[W nh[

BOOL CNo3Dlg::OnInitDialog()
{
	CDialogEx::OnInitDialog();

	// "o[W..." j[VXe j[ɒǉ܂B

	// IDM_ABOUTBOX ́AVXe R}h͈͓̔ɂȂ΂Ȃ܂B
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		BOOL bNameValid;
		CString strAboutMenu;
		bNameValid = strAboutMenu.LoadString(IDS_ABOUTBOX);
		ASSERT(bNameValid);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// ̃_CAÕACRݒ肵܂BAvP[ṼC EBhE_CAOłȂꍇA
	//  Framework ́A̐ݒIɍs܂B
	SetIcon(m_hIcon, TRUE);			// 傫ACR̐ݒ
	SetIcon(m_hIcon, FALSE);		// ACR̐ݒ

//	ShowWindow(SW_MINIMIZE);

	// TODO: ɒǉ܂B

	return TRUE;  // tH[JXRg[ɐݒ肵ꍇATRUE Ԃ܂B
}

void CNo3Dlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialogEx::OnSysCommand(nID, lParam);
	}
}

// _CAOɍŏ{^ǉꍇAACR`悷邽߂
//  ̃R[hKvłBhLg/r[ fg MFC AvP[V̏ꍇA
//  ́AFramework ɂĎIɐݒ肳܂B

void CNo3Dlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // `̃foCX ReLXg

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// NCAg̎lp`̈̒
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// ACR̕`
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialogEx::OnPaint();
	}
}

// [U[ŏEBhEhbOĂƂɕ\J[\擾邽߂ɁA
//  VXe̊֐Ăяo܂B
HCURSOR CNo3Dlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

/********************************************************************************/
/*		DispMsgBox																*/
/********************************************************************************/
int DispMsgBox(const char *fmt, ...)
{
	char buf[256];
	va_list ap;

	va_start(ap, fmt);
	vsprintf(buf, fmt, ap);				/* 쐬Tu[`				*/
	va_end(ap);

	MessageBox(0, buf, "", MB_OK);
	return 0;
}

/********************************************************************************/
/*		spskip																	*/
/*		linebufp ̈ʒũXy[XXLbv										*/
/********************************************************************************/
char *spskip(char *ptr)
{
	while (*ptr == ' ' || *ptr == '\t')
		ptr++;
	return ptr;
}

/********************************************************************************/
/*		getsym																	*/
/********************************************************************************/
char *getsym(char *ptr)
{
	char *pt;

	ptr = spskip(ptr);
	pt = symbuf;
	for (;;){
		if (*ptr == ' ' || *ptr == '\t' || *ptr == '\n' || *ptr == '\0'){
			*pt = '\0';
			return ptr;
		}
		*pt++ = *ptr++;
	}
}

/********************************************************************************/
/*		p[^̓t@Cǂݍ									*/
/*		return 0:error															*/
/********************************************************************************/
int paraminput(const char *filename)
{
	FILE *fp;
	char buf[1024], *pt;
	int i, i1;

	fp = fopen(filename, "r");
	if (fp == 0){
		MessageBox(0, "file open error", "", MB_OK);
		return 0;
	}
	i = 0;
	i1 = 0;
	while (fgets(buf, 1024, fp)){
		pt = getsym(buf);
		if(buf[0]=='#' || buf[0]=='\n'){	/* comment	*/
			continue;
		}
		else if (strcmp(symbuf, "begin") == 0){
			pt = getsym(pt);
			if(strcmp(symbuf, "element")==0){
				while (fgets(buf, 1024, fp)){
					pt = getsym(buf);
					if(buf[0]=='#' || buf[0]=='\n'){	/* comment	*/
						continue;
					}
					if (strcmp(symbuf, "L") == 0){
						type[i] = 'L';
					}
					else if(strcmp(symbuf, "C")==0){
						type[i] = 'C';
					}
					else if (strcmp(symbuf, "R") == 0){
						type[i] = 'R';
					}
					else if(strcmp(symbuf, "end")==0){
						break;
					}
					else{
						DispMsgBox("*** L/C/R/end need\n%s", buf);
						exit(1);
					}
					
					pt = getsym(pt);
					LCR_value[i] = atof(symbuf);
					
					pt = getsym(pt);
					node[0][i] = atoi(symbuf);
					if(node[0][i] > max_node){
						max_node = node[0][i];
					}
					
					pt = getsym(pt);
					node[1][i] = atoi(symbuf);
					if(node[1][i] > max_node){
						max_node = node[1][i];
					}
					
					if(node[0][i]>=MAXDANSUU || node[1][i]>=MAXDANSUU || node[0][i]==node[1][i]){
						DispMsgBox("*** node number error\n%s", buf);
						exit(1);
					}
					
					i++;
					if(i>MAXDANSUU){
						DispMsgBox("*** number of element over %d", MAXDANSUU);
						exit(1);
					}
				}
			}
			else if(strcmp(symbuf, "freq")==0){
				while(fgets(buf, 1024, fp)){
					pt = getsym(buf);
					if(buf[0]=='#' || buf[0]=='\n'){	/* comment	*/
						continue;
					}
					if(strcmp(symbuf, "gain_hosei")==0){
						pt = getsym(pt);
						gain_hosei = atof(symbuf);
					}
					else if (strcmp(symbuf, "f_max") == 0){
						pt = getsym(pt);
						f_max = atof(symbuf);
					}
					else if(strcmp(symbuf, "f_min")==0){
						pt = getsym(pt);
						f_min = atof(symbuf);
					}
					else if(strcmp(symbuf, "Y_max")==0){
						pt = getsym(pt);
						Y_max = atof(symbuf);
					}
					else if(strcmp(symbuf, "Y_memori")==0){
						pt = getsym(pt);
						Y_memori = atof(symbuf);
					}
					else if(strcmp(symbuf, "output_node")==0){
						pt = getsym(pt);
						output_node = atoi(symbuf);
					}
					else if(strcmp(symbuf, "end")==0){
						break;
					}
					else{
						DispMsgBox("*** syntax error\n%s", buf);
						exit(1);
					}
				}
			}
			else if(strcmp(symbuf, "hakei")==0){
				while(fgets(buf, 1024, fp)){
					pt = getsym(buf);
					if(buf[0]=='#' || buf[0]=='\n'){	/* comment	*/
						continue;
					}
					if(strcmp(symbuf, "sampling_period")==0){
						pt = getsym(pt);
						sampling_period = atof(symbuf);
					}
					else if(isdigit(symbuf[0]) || symbuf[0]=='-'){
						hakei_data[i1] = atof(symbuf);
						i1++;
					}
					else if(strcmp(symbuf, "end")==0){
						break;
					}
					else{
						DispMsgBox("*** syntax error\n%s", buf);
						exit(1);
					}
				}
			}
			else{
				DispMsgBox("*** element/freq/hakei need\n%s", buf);
				exit(1);
			}
		}
		else{
			DispMsgBox("error : %s", buf);
			exit(0);
		}
	}
	n_element = i;
	n_hakei = i1;
	fclose(fp);
	return 1;									/* success						*/
}
/********************************************************************************/
/*	make_Y									*/
/********************************************************************************/
void make_Y(double freq)
{
	complex<double> temp(0,0);
	int i, j, a, b;
	
	/*	clear	*/
	for(i=0; i<=max_node; i++){
		for(j=0; j<=max_node; j++){
			Y[i][j] = temp;
		}
	}
	/*	set Y	*/
	for(i=0; i<n_element; i++){
		a = node[0][i];
		b = node[1][i];
		if(type[i]=='L'){	/* y = 1/(jL)		*/
			temp.real(0);
			if(freq){
				temp.imag(-1/(2*PAI*freq*LCR_value[i]));
			}
			else{
				temp.imag(-1e10);
			}
			Y[a][a] += temp;
			Y[b][b] += temp;
			Y[a][b] -= temp;
			Y[b][a] -= temp;
		}
		else if(type[i]=='C'){	/* y = jC	*/
			temp.real(0);
			if(freq){
				temp.imag(2*PAI*freq*LCR_value[i]);
			}
			else{
				temp.imag(1e-10);
			}
			Y[a][a] += temp;
			Y[b][b] += temp;
			Y[a][b] -= temp;
			Y[b][a] -= temp;
		}
		else if(type[i]=='R'){	/* y = 1/R	*/
			temp.real(1/LCR_value[i]);
			temp.imag(0);
			Y[a][a] += temp;
			Y[b][b] += temp;
			Y[a][b] -= temp;
			Y[b][a] -= temp;
		}
		else{
			DispMsgBox("type error %x", type[i]);
			exit(1);
		}
	}
}
/********************************************************************************/
/*	solve_Y									*/
/*	node0: GND								*/
/*	node1: ͒[q(1V d)						*/
/********************************************************************************/
void solve_Y()
{
//	complex<double> zero(0,0);
	complex<double> temp;
	int i, j, k;
	
	for(i=2; i<=max_node; i++){	/* i ̓L[ƂȂs	*/
		if(abs(Y[i][i]) < 1e-10){	/* zero Ȃ΃XLbv	*/
			continue;
		}
		/*	i sK	*/
		temp = Y[i][i];
		for(j=1; j<=max_node; j++){
			Y[i][j] /= temp;
		}
		/*			*/
		for(j=2; j<=max_node; j++){	/* j ͌vZs	*/
			if(i==j){
				continue;
			}
			temp = Y[j][i];
			Y[j][1] -= Y[i][1] * temp;
			for(k=i; k<=max_node; k++){	/* k ͉XL	*/
				Y[j][k] -= Y[i][k] * temp;
			}
		}
	}
}
/********************************************************************************/
/*		response							*/
/********************************************************************************/
complex<double> response(double freq)
{
	make_Y(freq);
	solve_Y();
	return -Y[output_node][output_node] / Y[output_node][1];
}
/********************************************************************************/
/*		graph																	*/
/*		 1000hbgAc 700hbg												*/
/********************************************************************************/
void graph()
{
	int i, x, y, next;
	double step, a;
//	struct Z z;
	complex<double> z;
	
	CRect rect;
	CClientDC cdc(theApp.m_pMainWnd);
	CPen whitepen(PS_SOLID, 1, RGB(255, 255, 255));
	CBrush whitebrush(RGB(255, 255, 255));
	CPen blackpen(PS_SOLID, 1, RGB(0, 0, 0));
	CPen graypen(PS_SOLID, 1, RGB(192,192,192));
	CString str;
	
	/*** ʃNA		***/
	theApp.m_pMainWnd->GetClientRect(&rect);
	x = rect.Width();
	y = rect.Height();
	cdc.SelectObject(&whitepen);
	cdc.SelectObject(&whitebrush);
	cdc.Rectangle(0, 0, x, y);					/* ʃNA					*/
	/*** g		***/
	cdc.SelectObject(&graypen);				/* DF							*/
	cdc.SetTextColor(RGB(0,0,0));				/* F							*/
	cdc.SetBkColor(RGB(255,255,255));			/* obN						*/
	for(i=0; i<=10; i++){						/* c 10					*/
		cdc.MoveTo(50+i*100, 50);
		cdc.LineTo(50+i*100, 50+700);
		
		str.Format("%3.1f", 0.1*i);
		cdc.TextOut(50-10+i*100, 50+20+700, str);
	}
	str.Format("%1f[Hz]`%1f[Hz]", f_min, f_max);
	cdc.TextOut(10-50+500, 50+40+700, str);
	step = 700/Y_max;							/* 							*/
	for(i=0; ; i++){
		next = (int)(i*step*Y_memori+0.5);
		if(next >= 700)
			break;
		cdc.MoveTo(50, 50+next);
		cdc.LineTo(50+1000, 50+next);
		str.Format("%3.1f", i*Y_memori);
		cdc.TextOut(0, 50-6+next, str);
	}
	cdc.MoveTo(50, 50+700);
	cdc.LineTo(50+1000, 50+700);
	str.Format("%3.1f", Y_max);
	cdc.TextOut(0, 50 - 6 + 700, str);
	/*** g		***/
	cdc.SelectObject(&blackpen);				/* F							*/
	step = 700/Y_max;
	z = response(f_min);						/* g f_min ł̃X|X	*/
	a = 20*log10(abs(z));
	a -= gain_hosei;							/* 6dB ␳						*/
	cdc.MoveTo(50, 50+(int)(step*a+0.5));
	for(i=0; i<=1000; i++){
		z = response(f_min + (f_max-f_min)/1000*i);
		a = 20*log10(abs(z));
		a -= gain_hosei;						/* 6dB ␳						*/
		cdc.LineTo(50+i, 50+(int)(step*a+0.5));
	}
}

/********************************************************************************/
/*		dft																		*/
/*		Ut[Gϊ														*/
/********************************************************************************/
void dft()
{
	int k, n;
	complex<double> temp(0,0);
	
	for(k=0; k<n_hakei; k++){
		DFT[k] = temp;
	}
	for(k=0; k<n_hakei; k++){
		for(n=0; n<n_hakei; n++){
			temp.real(cos(2*PAI/n_hakei*k*n));
			temp.imag(-sin(2*PAI/n_hakei*k*n));
			DFT[k] += hakei_data[n] * temp;
		}
	}
}

/********************************************************************************/
/*		idft																	*/
/*		tUt[Gϊ														*/
/********************************************************************************/
void idft()
{
	int k, n;
	complex<double> temp(0,0);
	
	for(k=0; k<n_hakei; k++){
		IDFT[k] = temp;
	}
	for(n=0; n<n_hakei; n++){
		for(k=0; k<n_hakei; k++){
			temp.real(cos(2*PAI/n_hakei*k*n));
			temp.imag(sin(2*PAI/n_hakei*k*n));
			IDFT[n] += DFT[k] * temp;
		}
	}
	for(n=0; n<n_hakei; n++){
		IDFT[n] /= n_hakei;
	}
}

/********************************************************************************/
/*		waveform																*/
/*		 1000hbgAc 700hbg												*/
/********************************************************************************/
void waveform()
{
	int i, x, y;
	double step, a;
	complex<double> z;
	
	CRect rect;
	CClientDC cdc(theApp.m_pMainWnd);
	CPen whitepen(PS_SOLID, 1, RGB(255, 255, 255));
	CBrush whitebrush(RGB(255, 255, 255));
	CPen blackpen(PS_SOLID, 1, RGB(0, 0, 0));
	CPen graypen(PS_SOLID, 1, RGB(192,192,192));
	CString str;
	
	/*** ʃNA		***/
	theApp.m_pMainWnd->GetClientRect(&rect);
	x = rect.Width();
	y = rect.Height();
	cdc.SelectObject(&whitepen);
	cdc.SelectObject(&whitebrush);
	cdc.Rectangle(0, 0, x, y);					/* ʃNA					*/
	/*** g		***/
	cdc.SelectObject(&graypen);					/* DF							*/
	cdc.SetTextColor(RGB(0,0,0));				/* F							*/
	cdc.SetBkColor(RGB(255,255,255));			/* obN						*/
	for(i=0; i<=10; i++){						/* c 10					*/
		cdc.MoveTo(50+i*100, 50);
		cdc.LineTo(50+i*100, 50+70*4);
		
		cdc.MoveTo(50+i*100, 50+70*6);
		cdc.LineTo(50+i*100, 50+70*10);
		
		str.Format("%3.1f", 0.1*i);
		cdc.TextOut(50-10+i*100, 50+20+700, str);
	}
	str.Format("%1f[s]", sampling_period*n_hakei);
	cdc.TextOut(10-50+500, 50+40+700, str);
	for(i=0; i<=5 ; i++){						/* 							*/
		cdc.MoveTo(50, 50+70*2*i);
		cdc.LineTo(50+1000, 50+70*2*i);
	}
	for(i=0; i<3; i++){
		str.Format(" %d", 1-i);
		cdc.TextOut(0, 50-6+i*70*2, str);
		cdc.TextOut(0, 50-6+70*6+i*70*2, str);
	}
	/*** ̔g`		***/
	cdc.SelectObject(&blackpen);				/* F							*/
	cdc.MoveTo(50, 50+(int)floor((1-hakei_data[0])*70*2));
	step = 1/(sampling_period*1e-6*n_hakei);
	for(i=0; i<n_hakei; i++){
		cdc.LineTo(50+(int)(1000.0*i/n_hakei), 50+(int)floor((1-hakei_data[i])*70*2));
	}

	dft();										/* Ut[Gϊ				*/

	for(i=0; i<=n_hakei/2; i++){
		z = response(i*step);
		a = abs(z)*abs(z)/pow(10, gain_hosei/20);
		if(a==0)
			a = 1e-50;
		z = conj(z);
		DFT[i] = z * DFT[i] / a;
	}
	for(i=1; i<n_hakei/2; i++){
		DFT[n_hakei-i] = conj(DFT[i]);
	}
//	FILE *fp1=fopen("DFT.txt", "w");
//	for(i=0; i<n_hakei; i++){
//		fprintf(fp1, "%4d %f %f\n", i, DFT[i].real(), DFT[i].imag());
//	}
//	fclose(fp1);

	idft();										/* tUt[Gϊ			*/

//	FILE *fp=fopen("IDFT.txt", "w");
//	for(i=0; i<n_hakei; i++){
//		fprintf(fp, "%4d %f %f\n", i, IDFT[i].real(), IDFT[i].imag());
//	}
//	fclose(fp);
	/*** o͔g`		***/
	cdc.MoveTo(50, 50+70*6+(int)floor((1-IDFT[0].real())*70*2));
	for(i=0; i<n_hakei; i++){
		cdc.LineTo(50+(int)(1000.0*i/n_hakei), 50+70*6+(int)floor((1-IDFT[i].real())*70*2));
	}
}

/********************************************************************************/
/*		g																*/
/********************************************************************************/
void CNo3Dlg::OnBnClickedOk()
{
	CFileDialog filedlg(TRUE);

	if (filedlg.DoModal() == IDOK){
		if (paraminput(filedlg.GetPathName()) == 0)
			return;									/* error					*/
		graph();
	}
}

/********************************************************************************/
/*		g`																*/
/********************************************************************************/
void CNo3Dlg::OnBnClickedButton1()
{
	CFileDialog filedlg(TRUE);

	if (filedlg.DoModal() == IDOK){
		if (paraminput(filedlg.GetPathName()) == 0)
			return;									/* error					*/
		if(n_hakei != n_hakei/2*2){
			DispMsgBox("g`f[^łAɂĂ");
		}
		if(n_hakei==0){
			DispMsgBox("g`f[^L܂");
			return;
		}
		if(sampling_period==0){
			DispMsgBox("TvL܂");
			return;
		}
		waveform();
	}
}
